shell: syncronize ash_test/run-all and hush_test/run-all a bit

Signed-off-by: Denys Vlasenko <vda.linux@googlemail.com>
This commit is contained in:
Denys Vlasenko 2017-07-06 17:59:25 +02:00
parent 3c9688e587
commit 9a8ece5158
2 changed files with 83 additions and 72 deletions

View File

@ -1,6 +1,6 @@
#!/bin/sh #!/bin/sh
TOPDIR=$PWD TOPDIR=`pwd`
test -x ash || { test -x ash || {
echo "No ./ash - creating a link to ../../busybox" echo "No ./ash - creating a link to ../../busybox"
@ -10,67 +10,73 @@ test -x printenv || gcc -O2 -o printenv printenv.c || exit $?
test -x recho || gcc -O2 -o recho recho.c || exit $? test -x recho || gcc -O2 -o recho recho.c || exit $?
test -x zecho || gcc -O2 -o zecho zecho.c || exit $? test -x zecho || gcc -O2 -o zecho zecho.c || exit $?
PATH="$PWD:$PATH" # for ash and recho/zecho/printenv PATH="`pwd`:$PATH" # for ash and recho/zecho/printenv
export PATH export PATH
THIS_SH="$PWD/ash" THIS_SH="`pwd`/ash"
export THIS_SH export THIS_SH
do_test() do_test()
{ {
test -d "$1" || return 0 test -d "$1" || return 0
# echo do_test "$1" d=${d%/}
# $1 but with / replaced by # so that it can be used as filename part # echo Running tests in directory "$1"
noslash=`echo "$1" | sed 's:/:#:g'` # $1 but with / replaced by # so that it can be used as filename part
( noslash=`echo "$1" | sed 's:/:#:g'`
cd "$1" || { echo "cannot cd $1!"; exit 1; } (
for x in run-*; do cd "$1" || { echo "cannot cd $1!"; exit 1; }
test -f "$x" || continue for x in run-*; do
case "$x" in test -f "$x" || continue
"$0"|run-minimal|run-gprof) ;; case "$x" in
*.orig|*~) ;; "$0"|run-minimal|run-gprof) ;;
#*) echo $x ; sh $x ;; *.orig|*~) ;;
*) #*) echo $x ; sh $x ;;
echo -n "$1/$x: " *)
sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \ echo -n "$1/$x:"
{ echo "ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo "fail"; sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
;; { { echo " ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo " fail"; }
esac ;;
done esac
# Many bash run-XXX scripts just do this, done
# no point in duplication it all over the place # Many bash run-XXX scripts just do this,
for x in *.tests; do # no point in duplication it all over the place
test -x "$x" || continue for x in *.tests; do
name="${x%%.tests}" test -x "$x" || continue
test -f "$name.right" || continue name="${x%%.tests}"
echo -n "$1/$x: " test -f "$name.right" || continue
{ # echo Running test: "$x"
"$THIS_SH" "./$x" >"$name.xx" 2>&1 echo -n "$1/$x:"
diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \ {
&& rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail" "$THIS_SH" "./$x" >"$name.xx" 2>&1
} && echo "ok" || echo "fail" diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
done && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
) } && echo " ok" || echo " fail"
done
)
} }
# main part of this script # Main part of this script
# Usage: run-all [directories] # Usage: run-all [directories]
if [ $# -lt 1 ]; then ret=0
# All sub directories
modules=`ls -d ash-*`
# If you want to test ash against hush testsuite
# (have to copy hush_test dir to current dir first):
#modules=`ls -d ash-* hush_test/hush-*`
for module in $modules; do if [ $# -lt 1 ]; then
do_test $module # All sub directories
done modules=`ls -d ash-*`
# If you want to test ash against hush testsuite
# (have to copy hush_test dir to current dir first):
#modules=`ls -d ash-* hush_test/hush-*`
for module in $modules; do
do_test $module || ret=1
done
else else
while [ $# -ge 1 ]; do while [ $# -ge 1 ]; do
if [ -d $1 ]; then if [ -d $1 ]; then
do_test $1 do_test $1 || ret=1
fi fi
shift shift
done done
fi fi
exit ${ret}

View File

@ -9,6 +9,8 @@ unset LC_NUMERIC
unset LC_TIME unset LC_TIME
unset LC_ALL unset LC_ALL
TOPDIR=`pwd`
if test ! -x hush; then if test ! -x hush; then
if test ! -x ../../busybox; then if test ! -x ../../busybox; then
echo "Can't run tests. Put hush binary into this directory (`pwd`)" echo "Can't run tests. Put hush binary into this directory (`pwd`)"
@ -38,6 +40,8 @@ do_test()
test -d "$1" || return 0 test -d "$1" || return 0
d=${d%/} d=${d%/}
# echo Running tests in directory "$1" # echo Running tests in directory "$1"
# $1 but with / replaced by # so that it can be used as filename part
noslash=`echo "$1" | sed 's:/:#:g'`
( (
tret=0 tret=0
cd "$1" || { echo "cannot cd $1!"; exit 1; } cd "$1" || { echo "cannot cd $1!"; exit 1; }
@ -49,34 +53,35 @@ do_test()
#*) echo $x ; sh $x ;; #*) echo $x ; sh $x ;;
*) *)
echo -n "$1/$x:" echo -n "$1/$x:"
sh "$x" >"../$1-$x.fail" 2>&1 && \ sh "$x" >"$TOPDIR/$noslash-$x.fail" 2>&1 && \
{ { echo " ok"; rm "../$1-$x.fail"; } || echo " fail"; } { { echo " ok"; rm "$TOPDIR/$noslash-$x.fail"; } || echo " fail"; }
;; ;;
esac esac
done done
# Many bash run-XXX scripts just do this, # Many bash run-XXX scripts just do this,
# no point in duplication it all over the place # no point in duplication it all over the place
for x in *.tests; do for x in *.tests; do
test -x "$x" || continue test -x "$x" || continue
name="${x%%.tests}" name="${x%%.tests}"
test -f "$name.right" || continue test -f "$name.right" || continue
# echo Running test: "$x" # echo Running test: "$x"
echo -n "$1/$x:" echo -n "$1/$x:"
( (
"$THIS_SH" "./$x" >"$name.xx" 2>&1 "$THIS_SH" "./$x" >"$name.xx" 2>&1
r=$? r=$?
# filter C library differences # filter C library differences
sed -i \ sed -i \
-e "/: invalid option /s:'::g" \ -e "/: invalid option /s:'::g" \
"$name.xx" "$name.xx"
test $r -eq 77 && rm -f "../$1-$x.fail" && exit 77 test $r -eq 77 && rm -f "$TOPDIR/$noslash-$x.fail" && exit 77
diff -u "$name.xx" "$name.right" >"../$1-$x.fail" && rm -f "$name.xx" "../$1-$x.fail" diff -u "$name.xx" "$name.right" >"$TOPDIR/$noslash-$x.fail" \
) && rm -f "$name.xx" "$TOPDIR/$noslash-$x.fail"
case $? in )
0) echo " ok";; case $? in
77) echo " skip (feature disabled)";; 0) echo " ok";;
*) echo " fail"; tret=1;; 77) echo " skip (feature disabled)";;
esac *) echo " fail"; tret=1;;
esac
done done
exit ${tret} exit ${tret}
) )
@ -92,7 +97,7 @@ if [ $# -lt 1 ]; then
modules=`ls -d hush-*` modules=`ls -d hush-*`
for module in $modules; do for module in $modules; do
do_test $module || ret=1 do_test $module || ret=1
done done
else else
while [ $# -ge 1 ]; do while [ $# -ge 1 ]; do